<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '主键',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retPacketCode',
    label: '回执文件数据包编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retPacketName',
    label: '回执文件数据包名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retPacketContent',
    label: '回执文件数据包名称的内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'repPacketCode',
    label: '上报数据包编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'repPacketName',
    label: '上报数据包名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retXmlCode',
    label: '回执文件编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retXmlName',
    label: '回执文件名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retXmlContent',
    label: '回执文件内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retTime',
    label: '回执文件上传时间',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retParseStatus',
    label: '回执文件解析状态',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retType',
    label: '回执文件错误原因',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ertDealStatus',
    label: '回执文件处理状态',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retOrgancode',
    label: '机构编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'retOrganname',
    label: '机构名称',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

